package projects.gemoma;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;

public class BestReciprocalHit {

	/**
	 * @param args
	 * 0 bestHit-A-on-B
	 * 1 bestHit-B-on-A
	 * 2 transcriptExonAssignments A
	 * 3 out
	 */
	public static void main(String[] args) throws Exception {	
		//read and save prediction
		HashMap<String, Hit> hash1 = read( args[0] );
		HashMap<String, Hit> hash2 = read( args[1] );

		//process prediction
		BufferedReader r = new BufferedReader( new FileReader( args[2] ) );
		Hit current, h;
		HashSet<String> gene = new HashSet<String>();
		ArrayList<Hit> best = new ArrayList<Hit>();
		double bestF1;
		BufferedWriter w = new BufferedWriter( new FileWriter(args[3]) );
		String line;
		ArrayList<String[]> transcripts = new ArrayList<String[]>();
		HashMap<String, String> transcriptMap = new HashMap<String, String>();
		String[] split;
		while( (line=r.readLine()) != null ) {
			if( line.startsWith("#") ) {
				continue;
			}
			split = line.split("\t");
			transcripts.add(split);
			transcriptMap.put(split[1], split[0]);
		}
		
		for( int k = 0; k < transcripts.size(); k++ ) {
			split = transcripts.get(k);
			w.append( split[0] + "\t" + split[1] );
			
			h = hash1.get(split[1]);
			bestF1=-1;
			best.clear();
			boolean pred=false;
			
			if( h == null ) {
				for( int i = 0; i < 10; i++ ) {
					w.append("\tNA");
				}
			} else {
				w.append( h.toString() );
				for( int i = 0; i < h.matches.length; i++ ) {
					current = hash2.get( h.matches[i] );
					if( current != null ) {
						pred=true;
						if( bestF1 <= current.f1 ) {
							if( bestF1 < current.f1 ) {
								best.clear();
							}
							if( best.size() == 0 ) {
								bestF1=current.f1;
							}
							best.add( current );
						}
					}
				}
			}
			w.append( "\t" + (pred?best.size():-1) + "\t" + (pred?bestF1:"NA") );
			
			if( best.size() != 0 && h!= null && h.f1 >= 0 ) {
				//transcript org. 2
				gene.clear();
				for( int i = 0; i < best.size(); i++ ) {
					gene.add(best.get(i).id);
				}
				w.append( "\t" + toString( gene.toArray() ) );
				
				//transcript org. 1
				gene.clear();
				for( int i = 0; i < best.size(); i++ ) {
					current = best.get(i);
					for( int j = 0; j < current.matches.length; j++ ) {
						gene.add(current.matches[j]);
					}
				}
				Object[] o=gene.toArray();
				w.append( "\t" + toString( o ) );
w.flush();
				//gene org. 1
				gene.clear();
				for( int i = 0; i <o.length; i++ ) {
					gene.add( transcriptMap.get( o[i] ) );
				}
				w.append( "\t" + toString( gene.toArray() ) );
				
			} else {
				for( int i = 0; i < 3; i++ ) {
					w.append( "\tNA");
				}
			}
			w.newLine();
		}
		r.close();
		w.close();
	}
	
	public static HashMap<String, Hit> read( String fileName ) throws Exception {
		//read and save prediction
		HashMap<String, Hit> hash = new HashMap<String, Hit>();
		BufferedReader r = new BufferedReader( new FileReader( fileName ) );
		String line;
		while( (line=r.readLine()) != null ) {
			if( !line.startsWith("#") ) {
				Hit h = new Hit(line);
				if( hash.containsKey(h.id) ) {
					throw new IllegalArgumentException(h.id);
				}
				hash.put(h.id, h);
			}
		}
		r.close();
		return hash;
	}
	
    public static String toString(Object[] a) {
    	int iMax = a.length - 1;
        StringBuilder b = new StringBuilder();
        for (int i = 0; i < a.length; i++) {
            b.append(String.valueOf(a[i]));
            if (i < iMax)
                b.append(", ");
        }
        return b.toString();
    }

	static class Hit {
		String geneID, id, line;
		double f1;
		String[] matches;
		
		Hit( String line ) {
			this.line = line;
			String[] split = line.split("\t");
			id = split[1];
			geneID = split[0];
			if( split[split.length-2].equals("NA") ) {
				f1 = Double.NaN;
			} else {
				f1 = Double.parseDouble(split[split.length-2]);
			}
			matches = split[split.length-1].split(";");
			for( int i = 0; i < matches.length; i++ ) {
				matches[i] = matches[i].split(",")[0];
			}		
		}
		
		
		
		public String toString() {
			int idx = line.indexOf('\t');
			idx = line.indexOf('\t',idx+1);
			return line.substring(idx);
		}
	}
}
